{ copyright  Grahame Grieve
  refer to xyGraph.pas, xyGraph.hlp for more information }

unit Xydesign;
              
{$I xyDefine.pas}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, {$IFDEF WIN32} ComCtrls, {$ENDIF} ExtCtrls,
  Spin, Buttons, TabNotBk, Tabs, xygraph, xydata;

type
  TxyEdit = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    fd: TFontDialog;
    cd: TColorDialog;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Notebook1: TNotebook;
    _MainPanel: TPanel;
    Bevel10: TBevel;
    Bevel7: TBevel;
    Label34: TLabel;
    Label37: TLabel;
    Label36: TLabel;
    Label38: TLabel;
    Label33: TLabel;
    Label31: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label35: TLabel;
    Label40: TLabel;
    Label42: TLabel;
    Label41: TLabel;
    Label32: TLabel;
    Label30: TLabel;
    Bevel9: TBevel;
    CheckBox10: TCheckBox;
    Edit4: TEdit;
    Edit5: TEdit;
    CheckBox11: TCheckBox;
    Edit6: TEdit;
    CheckBox7: TCheckBox;
    CheckBox9: TCheckBox;
    Edit3: TEdit;
    SpinEdit12: TSpinEdit;
    SpinEdit13: TSpinEdit;
    CheckBox13: TCheckBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Edit7: TEdit;
    ComboBox2: TComboBox;
    Edit2: TEdit;
    CheckBox8: TCheckBox;
    TabbedNotebook1: TTabbedNotebook;
    Label3: TLabel;
    Label24: TLabel;
    Label14: TLabel;
    Label26: TLabel;
    Label12: TLabel;
    Label28: TLabel;
    Label27: TLabel;
    Label1: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label5: TLabel;
    Label15: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    Label17: TLabel;
    Label16: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Edit1: TEdit;
    Button3: TButton;
    SpinEdit1: TSpinEdit;
    Button7: TButton;
    SpinEdit10: TSpinEdit;
    SpinEdit11: TSpinEdit;
    Button11: TButton;
    CheckBox3: TCheckBox;
    SpinEdit9: TSpinEdit;
    SpinEdit8: TSpinEdit;
    CheckBox4: TCheckBox;
    SpinEdit2: TSpinEdit;
    SpinEdit4: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Panel2: TPanel;
    Label50: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label51: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Bevel8: TBevel;
    SpinEdit16: TSpinEdit;
    SpinEdit18: TSpinEdit;
    SpinEdit19: TSpinEdit;
    SpinEdit17: TSpinEdit;
    SpinEdit20: TSpinEdit;
    SpinEdit21: TSpinEdit;
    SpinEdit22: TSpinEdit;
    CheckBox16: TCheckBox;
    Button6: TButton;
    Button15: TButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    Panel17: TPanel;
    CheckBox15: TCheckBox;
    Panel20: TPanel;
    Label59: TLabel;
    Label60: TLabel;
    ListBox1: TListBox;
    ComboBox8: TComboBox;
    Bevel6: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Label20: TLabel;
    Label10: TLabel;
    Label4: TLabel;
    Label22: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    Label13: TLabel;
    Label11: TLabel;
    Label29: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label2: TLabel;
    Label25: TLabel;
    Button9: TButton;
    Button1: TButton;
    Button2: TButton;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    SpinEdit7: TSpinEdit;
    Button10: TButton;
    gridstyle: TComboBox;
    CheckBox12: TCheckBox;
    SpinEdit14: TSpinEdit;
    Button5: TButton;
    fGraph: TxyGraph;
    Bevel11: TBevel;
    Bevel12: TBevel;
    procedure Edit1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure closebutClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure SpinEdit8Change(Sender: TObject);
    procedure SpinEdit9Change(Sender: TObject);
    procedure SpinEdit10Change(Sender: TObject);
    procedure SpinEdit11Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure SpinEdit5Change(Sender: TObject);
    procedure SpinEdit6Change(Sender: TObject);
    procedure SpinEdit7Change(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure gridstyleChange(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure CheckBox9Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure SpinEdit12Change(Sender: TObject);
    procedure SpinEdit13Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox8Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure CheckBox10Click(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
    procedure CheckBox11Click(Sender: TObject);
    procedure Edit6Change(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Edit7Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
{    procedure Edit10Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure RadioButton7Click(Sender: TObject);
    procedure ComboBox10Change(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure ComboBox11Change(Sender: TObject);
    procedure SpinEdit15Change(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure CheckBox14Click(Sender: TObject);
    procedure Edit11Change(Sender: TObject);
    procedure ComboBox12Change(Sender: TObject);}
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button5Click(Sender: TObject);
    procedure CheckBox12Click(Sender: TObject);
    procedure SpinEdit14Change(Sender: TObject);
    procedure CheckBox13Click(Sender: TObject);
    procedure CheckBox15Click(Sender: TObject);
    procedure SpinEdit16Change(Sender: TObject);
    procedure SpinEdit17Change(Sender: TObject);
    procedure SpinEdit18Change(Sender: TObject);
    procedure SpinEdit19Change(Sender: TObject);
    procedure SpinEdit20Change(Sender: TObject);
    procedure SpinEdit21Change(Sender: TObject);
    procedure SpinEdit22Change(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure CheckBox16Click(Sender: TObject);
    procedure Button15Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ComboBox8Change(Sender: TObject);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
    editing:boolean;
    currentAxis:TAxis;
    hideshape:TPanel;
    procedure updateaxespage;
    procedure updatelegendpage;

    procedure SetGraph(v:TxyGraph);
  public
    { Public declarations }
{    fgraph: txygraph;}
    property Graph:TxyGraph read FGraph write SetGraph;
  end;

var
  xyEdit: TxyEdit;

function editxyGraph(AOwner:TComponent; AxyGraph:TxyGraph):boolean;

implementation

{$R *.DFM}

{----------------------------------------------------------------------------
    #1a. set up
 ----------------------------------------------------------------------------}

procedure TxyEdit.SetGraph;
begin
 fgraph.assign(v);
end;

procedure TxyEdit.FormShow(Sender: TObject);
begin
{  checkbox2.checked := FGraph.Appearance.allowduplicates;
}
  {general page}
  edit1.text := FGraph.appearance.graphtitle;
  spinedit1.value := FGraph.dimensions.graphtitleoffset;
  spinedit8.value := FGraph.dimensions.topmargin;
  spinedit9.value := FGraph.dimensions.bottommargin;
  spinedit10.value := FGraph.dimensions.leftmargin;
  spinedit11.value := FGraph.dimensions.rightmargin;
  spinedit5.value := FGraph.dimensions.Ticklength;
  checkbox3.checked := FGraph.appearance.plotoffgraph;
  Checkbox5.checked := fgraph.appearance.showgraphlabels;
  Checkbox6.checked := fgraph.appearance.showticks;
  SpinEdit6.value := fgraph.appearance.MaxSteps;
  SpinEdit7.value := fgraph.appearance.MinSteps;
  case fgraph.appearance.gridstyle of
    psSolid:gridstyle.itemindex := 0;
    psDot:gridstyle.itemindex := 1;
    psDash:gridstyle.itemindex := 2;
    psDashDot:gridstyle.itemindex :=3 ;
    psDashDotDot:gridstyle.itemindex := 4;
  end;
  Spinedit2.value := FGraph.Dimensions.printscalepct;
  spinedit3.value := fgraph.dimensions.PrintXOffsetPct;
  spinedit4.value := fgraph.dimensions.PrintYOffsetPct;
  checkbox4.checked := FGraph.appearance.PrintBkgndcolor;
  checkbox12.checked := FGraph.Appearance.CrossAtZero;
  spinedit14.value := FGraph.Appearance.CrossLength;

{axes page}
  currentaxis := FGraph.XAxis;
 {  1:currentaxis := FGraph.YAxis;}
{  2:currentaxis := FGraph.YAxis_Second;}
  updateaxespage;

  {legend page}
  updatelegendpage;

  editing := true;
end;

procedure TxyEdit.updateaxespage;
var oedit:boolean;
begin
  oedit := editing;
  editing := false;
  checkbox7.checked := currentaxis.showaxis;
  checkbox9.checked := currentaxis.gridlines;
  edit3.text := currentaxis.title;
  if currentaxis = FGraph.xaxis then
    begin
    Spinedit12.value := FGraph.dimensions.XAxisTitleOffset;
    Spinedit13.value := FGraph.dimensions.XAxisLabelOffset
    end
  else
    begin
    Spinedit12.value := FGraph.dimensions.YAxisTitleOffset;
    Spinedit13.value := FGraph.dimensions.YAxisLabelOffset;
    end;
  case currentaxis.offsettype of
    ao_minimum: combobox2.itemindex := 0;
    ao_Maximum: combobox2.itemindex := 1;
    ao_percentage: combobox2.itemindex := 2;
    ao_absolute: combobox2.itemindex := 3;
  end;
  if combobox2.itemindex > 1 then
    edit2.enabled := true
  else
    edit2.enabled := false;
  edit2.text := floattostrF(currentaxis.offset,ffFixed, 2,2);
  checkbox8.checked := currentaxis.Reversed;
  checkbox10.checked := currentaxis.autosizing;
  edit4.enabled := not checkbox10.checked;
  edit4.text := floattostrF(currentaxis.min,ffFixed, 2,2);
  edit5.enabled := not checkbox10.checked;
  edit5.text := floattostrF(currentaxis.max,ffFixed, 2,2);
  checkbox11.checked := currentaxis.autostepping;
  edit6.enabled := not checkbox11.checked;
  edit6.text := floattostrF(currentaxis.stepsize,ffFixed, 2,2);
  if currentaxis.logscale then
    begin
    radiobutton2.checked := true;
    RadioButton1Click(radiobutton2);
    end
  else if currentaxis.showastime then
    begin
    radiobutton3.checked := true;
    RadioButton1Click(radiobutton3);
    end
  else
    begin
    radiobutton1.checked := true;
    RadioButton1Click(radiobutton1);
    end;
  case currentaxis.LogCycleDivisions of
     0:combobox3.itemindex := 0;
     1:combobox3.itemindex := 1;
     2:combobox3.itemindex := 2;
     5:combobox3.itemindex := 3;
     7:combobox3.itemindex := 4;
     9:combobox3.itemindex := 5;
    end;
  edit7.text := currentaxis.DateTimeFormat;
  case currentaxis.DateTickType of
    dt_minute:Combobox4.itemindex := 0;
    dt_5minute:Combobox4.itemindex := 1;
    dt_halfhourly:Combobox4.itemindex := 2;
    dt_hourly:Combobox4.itemindex := 3;
    dt_daily:Combobox4.itemindex := 4;
    dt_weekly:Combobox4.itemindex := 5;
    dt_monthly:Combobox4.itemindex := 6;
    dt_2monthly:Combobox4.itemindex := 7;
    dt_quarterly:Combobox4.itemindex := 8;
    dt_annually:Combobox4.itemindex := 9;
    dt_decade:Combobox4.itemindex := 10;
    dt_century:Combobox4.itemindex := 11;
    dt_custom:Combobox4.itemindex := 12;
  end;
  checkbox13.checked :=  currentaxis.AutoLabelDecimals;
  editing := oedit;
end;

procedure TxyEdit.closebutClick(Sender: TObject);
begin
  close;
end;

procedure TxyEdit.FormCreate(Sender: TObject);
begin
 _MainPanel.color := clBtnFace;
 editing := false;
(* {$IFNDEF STATISTICS}
 hideshape := TPanel.create(self);
 hideshape.parent := panel19;
 hideshape.top := 73;
 hideshape.left := 6;
 hideshape.width := panel19.width - (6 + 3);
 hideshape.height := panel19.height - (73 + 3);
 hideshape.bevelOuter := bvnone;
 {$ENDIF}*)
end;

procedure TxyEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
hideshape.free;
end;


{----------------------------------------------------------------------------
    #1a. update graph
 ----------------------------------------------------------------------------}

procedure TxyEdit.Edit1Change(Sender: TObject);
begin
  if editing then fgraph.appearance.graphtitle := edit1.text;
end;

procedure TxyEdit.SpinEdit1Change(Sender: TObject);
begin
 if editing then FGraph.dimensions.graphtitleoffset := spinedit1.value;
end;

procedure TxyEdit.Button3Click(Sender: TObject);
begin
  fd.font := FGraph.appearance.captionfont;
  if fd.execute then FGraph.appearance.captionFont := fd.font;
end;

procedure TxyEdit.Button7Click(Sender: TObject);
begin
  cd.color := FGraph.appearance.BackgroundColor;
  if cd.execute then
    FGraph.appearance.backgroundcolor := cd.color;
end;

procedure TxyEdit.SpinEdit8Change(Sender: TObject);
begin
 if editing then FGraph.dimensions.topmargin := spinedit8.value;
end;

procedure TxyEdit.SpinEdit9Change(Sender: TObject);
begin
 if editing then FGraph.dimensions.bottommargin := spinedit9.value;
end;

procedure TxyEdit.SpinEdit10Change(Sender: TObject);
begin
 if editing then FGraph.dimensions.leftmargin := spinedit10.value;
end;

procedure TxyEdit.SpinEdit11Change(Sender: TObject);
begin
 if editing then FGraph.dimensions.rightmargin := spinedit11.value;
end;

procedure TxyEdit.CheckBox3Click(Sender: TObject);
begin
  if editing then FGraph.appearance.plotoffgraph := checkbox3.checked;
end;

procedure TxyEdit.Button11Click(Sender: TObject);
begin
  cd.color := FGraph.Appearance.Margincolor;
  if cd.execute then FGraph.Appearance.Margincolor := cd.color;
end;

procedure TxyEdit.Button9Click(Sender: TObject);
begin
  cd.color := FGraph.appearance.axesColor;
  if cd.execute then
    FGraph.appearance.axescolor := cd.color;
end;

procedure TxyEdit.Button1Click(Sender: TObject);
begin
  fd.font := FGraph.appearance.Titlefont;
  if fd.execute then FGraph.appearance.Titlefont := fd.font;
end;

procedure TxyEdit.Button2Click(Sender: TObject);
begin
  fd.font := FGraph.appearance.labelfont;
  if fd.execute then FGraph.appearance.labelfont := fd.font;
end;

procedure TxyEdit.CheckBox5Click(Sender: TObject);
begin
 if editing then fgraph.appearance.showgraphlabels := Checkbox5.checked;
end;

procedure TxyEdit.CheckBox6Click(Sender: TObject);
begin
 if editing then fgraph.appearance.showticks := Checkbox6.checked;
end;

procedure TxyEdit.SpinEdit5Change(Sender: TObject);
begin
  if editing then fgraph.dimensions.Ticklength := SpinEdit5.value;
end;

procedure TxyEdit.SpinEdit6Change(Sender: TObject);
begin
  if editing then fgraph.appearance.MaxSteps := SpinEdit6.value;
end;

procedure TxyEdit.SpinEdit7Change(Sender: TObject);
begin
  if editing then fgraph.appearance.MinSteps := SpinEdit7.value;
end;

procedure TxyEdit.Button10Click(Sender: TObject);
begin
 cd.color := fgraph.appearance.gridcolor;
 if cd.execute then fgraph.appearance.gridcolor := cd.color;
end;

procedure TxyEdit.gridstyleChange(Sender: TObject);
begin
  if not editing then exit;
  case gridstyle.itemindex of
    0:fgraph.appearance.gridstyle := psSolid;
    1:fgraph.appearance.gridstyle := psDot;
    2:fgraph.appearance.gridstyle := psDash;
    3:fgraph.appearance.gridstyle := psDashDot;
    4:fgraph.appearance.gridstyle := psDashDotDot;
  end;
end;

procedure TxyEdit.SpinEdit2Change(Sender: TObject);
begin
  if editing then FGraph.Dimensions.printscalepct := Spinedit2.value;
end;

procedure TxyEdit.SpinEdit3Change(Sender: TObject);
begin
  if editing then fgraph.dimensions.PrintXOffsetPct := spinedit3.value;
end;

procedure TxyEdit.SpinEdit4Change(Sender: TObject);
begin
  if editing then fgraph.dimensions.PrintYOffsetPct := spinedit4.value;
end;

procedure TxyEdit.CheckBox4Click(Sender: TObject);
begin
  if editing then FGraph.appearance.PrintBkgndcolor := checkbox4.checked;
end;

procedure TxyEdit.CheckBox7Click(Sender: TObject);
begin
  if editing then currentaxis.showaxis := checkbox7.checked;
end;

procedure TxyEdit.CheckBox9Click(Sender: TObject);
begin
  if editing then currentaxis.gridlines := checkbox9.checked;
end;

procedure TxyEdit.Edit3Change(Sender: TObject);
begin
  if editing then currentaxis.title := edit3.text;
end;

procedure TxyEdit.SpinEdit12Change(Sender: TObject);
begin
  if not editing then exit;
  if currentaxis = FGraph.xaxis then
    FGraph.dimensions.XAxisTitleOffset := Spinedit12.value
  else
    FGraph.dimensions.YAxisTitleOffset := Spinedit12.value
end;

procedure TxyEdit.SpinEdit13Change(Sender: TObject);
begin
  if not editing then exit;
  if currentaxis = FGraph.xaxis then
    FGraph.dimensions.XAxisLabelOffset := Spinedit13.value
  else
    FGraph.dimensions.YAxisLabelOffset := Spinedit13.value
end;

procedure TxyEdit.ComboBox2Change(Sender: TObject);
begin
  if combobox2.itemindex > 1 then
    edit2.enabled := true
  else
    edit2.enabled := false;
  if not editing then exit;
  case combobox2.itemindex of
    0:currentaxis.offsettype := ao_minimum;
    1:currentaxis.offsettype := ao_Maximum;
    2:currentaxis.offsettype := ao_percentage;
    3:currentaxis.offsettype := ao_absolute;
  end;
end;

procedure TxyEdit.CheckBox8Click(Sender: TObject);
begin
  if editing then currentaxis.Reversed := checkbox8.checked;
end;

procedure TxyEdit.Edit2Change(Sender: TObject);
begin
  if editing then currentaxis.offset := strtofloat(edit2.text);
end;

procedure TxyEdit.CheckBox10Click(Sender: TObject);
begin
  edit4.enabled := not checkbox10.checked;
  edit5.enabled := not checkbox10.checked;
  if editing then
    begin
    currentaxis.autosizing := checkbox10.checked;
    edit4.text := floattostrF(currentaxis.min,ffFixed, 2,2);
    edit5.text := floattostrF(currentaxis.max,ffFixed, 2,2);
    if checkbox11.checked then
       edit6.text := floattostrF(currentaxis.stepsize,ffFixed, 2,2);
    end;
end;

procedure TxyEdit.Edit4Change(Sender: TObject);
begin
  if editing then
    begin
    currentaxis.min := strtofloat(edit4.text);
    if checkbox11.checked then
       edit6.text := floattostrF(currentaxis.stepsize,ffFixed, 2,2);
    end;
end;

procedure TxyEdit.Edit5Change(Sender: TObject);
begin
  if editing then
    begin
    currentaxis.max := strtofloat(edit5.text);
    if checkbox11.checked then
       edit6.text := floattostrF(currentaxis.stepsize,ffFixed, 2,2);
    end;
end;

procedure TxyEdit.CheckBox11Click(Sender: TObject);
begin
  edit6.enabled := not checkbox11.checked;
  if editing then
    begin
    currentaxis.autostepping := checkbox11.checked;
    edit6.text := floattostrF(currentaxis.stepsize,ffFixed, 2,2);
    end;
end;

procedure TxyEdit.Edit6Change(Sender: TObject);
begin
  if editing then
    currentaxis.stepsize := strtofloat(edit6.text);
end;

procedure TxyEdit.RadioButton1Click(Sender: TObject);
begin
  case TComponent(sender).tag of
    0:begin
      combobox3.enabled := false;
      combobox4.enabled := false;
      edit7.enabled := false;
      end;
    1:begin
      combobox3.enabled := true;
      combobox4.enabled := false;
      edit7.enabled := false;
      end;
    2:begin
      combobox3.enabled := false;
      combobox4.enabled := true;
      edit7.enabled := true;
      end;
  end;
  if not editing then exit;
  case TComponent(sender).tag of
    0:begin
      currentaxis.logscale := false;
      currentaxis.ShowAsTime := false;
      end;
    1:begin
      currentaxis.ShowAsTime := false;
      currentaxis.logscale := true;
      end;
    2:begin
      currentaxis.logscale := false;
      currentaxis.ShowAsTime := true;
      end;
  end;
end;

procedure TxyEdit.ComboBox3Change(Sender: TObject);
begin
  if editing then
    case combobox3.itemindex of
     0:currentaxis.LogCycleDivisions := 0;
     1:currentaxis.LogCycleDivisions := 1;
     2:currentaxis.LogCycleDivisions := 2;
     3:currentaxis.LogCycleDivisions := 5;
     4:currentaxis.LogCycleDivisions := 7;
     5:currentaxis.LogCycleDivisions := 9;
    end;
end;

procedure TxyEdit.Edit7Change(Sender: TObject);
begin
  if editing then currentaxis.DateTimeFormat := edit7.text;
end;

procedure TxyEdit.ComboBox4Change(Sender: TObject);
begin
  if not editing then exit;
  case Combobox4.itemindex of
    00:currentaxis.DateTickType := dt_minute;
    01:currentaxis.DateTickType := dt_5minute;
    02:currentaxis.DateTickType := dt_halfhourly;
    03:currentaxis.DateTickType := dt_hourly;
    04:currentaxis.DateTickType := dt_daily;
    05:currentaxis.DateTickType := dt_weekly;
    06:currentaxis.DateTickType := dt_monthly;
    07:currentaxis.DateTickType := dt_2monthly;
    08:currentaxis.DateTickType := dt_quarterly;
    09:currentaxis.DateTickType := dt_annually;
    10:currentaxis.DateTickType := dt_decade;
    11:currentaxis.DateTickType := dt_century;
    12:currentaxis.DateTickType := dt_custom;
  end;
end;

procedure TxyEdit.Button5Click(Sender: TObject);
begin
  cd.color := FGraph.appearance.CrossColor;
  if cd.execute then
    FGraph.appearance.Crosscolor := cd.color;
end;

procedure TxyEdit.CheckBox12Click(Sender: TObject);
begin
 if editing then fgraph.appearance.CrossAtZero := Checkbox12.checked;
end;

procedure TxyEdit.SpinEdit14Change(Sender: TObject);
begin
  if editing then fgraph.Appearance.Crosslength := SpinEdit14.value;
end;

procedure TxyEdit.CheckBox13Click(Sender: TObject);
begin
  if editing then currentaxis.AutoLabelDecimals := checkbox11.checked;
end;

procedure TxyEdit.updateLegendPage;
var oedit:boolean;
    p:TSeries;
    i:integer;
begin
  ListBox1.items.clear;
  oedit := editing;
  editing := false;
  checkbox15.checked := fgraph.legend.visible;
  spinedit16.value := fgraph.legend.left;
  spinedit17.value := fgraph.legend.top;
  spinedit18.value := fgraph.legend.width;
  spinedit19.value := fgraph.legend.height;
  spinedit20.value := fgraph.legend.xmargin;
  spinedit21.value := fgraph.legend.ymargin;
  spinedit22.value := fgraph.legend.symbolspace;
  case fGraph.legend.Layout of
    lsAcross:radiobutton4.checked := true;
    lsDown  :radiobutton5.checked := true;
  end;
  checkbox16.checked := (FGraph.legend.Borderstyle = bsSingle);
  p := FGraph.serieshandle;
  i := 0;
  if p = nil then
    combobox8.enabled := false
 else combobox8.enabled := true;
 while p <> nil do
   begin
   listbox1.items.addobject(p.SeriesName,tobject(p.SeriesIndex));
   inc(i);
   p := p.nextSeries;
   end;
 if listbox1.itemindex < 0 then listbox1.itemindex := 0;
 if combobox8.enabled then
  case fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus of
   lsNone    :combobox8.itemindex := 0;
   lsNameOnly:combobox8.itemindex := 1;
   lsPoints  :combobox8.itemindex := 2;
   lsLines   :combobox8.itemindex := 3;
   lsAll     :combobox8.itemindex := 4;
 end;
 editing := oedit;
end;

procedure TxyEdit.CheckBox15Click(Sender: TObject);
begin
  if editing then fgraph.legend.visible := checkbox15.checked;
end;

procedure TxyEdit.SpinEdit16Change(Sender: TObject);
begin
  if editing then  fgraph.legend.left := spinedit16.value;
end;

procedure TxyEdit.SpinEdit17Change(Sender: TObject);
begin
  if editing then fgraph.legend.top := spinedit17.value;
end;

procedure TxyEdit.SpinEdit18Change(Sender: TObject);
begin
  if editing then fgraph.legend.width := spinedit18.value;
end;

procedure TxyEdit.SpinEdit19Change(Sender: TObject);
begin
  if editing then fgraph.legend.height := spinedit19.value;
end;

procedure TxyEdit.SpinEdit20Change(Sender: TObject);
begin
  if editing then fgraph.legend.xmargin := spinedit20.value;
end;

procedure TxyEdit.SpinEdit21Change(Sender: TObject);
begin
  if editing then fgraph.legend.ymargin := spinedit21.value;
end;

procedure TxyEdit.SpinEdit22Change(Sender: TObject);
begin
  if editing then fgraph.legend.symbolspace := spinedit22.value;
end;

procedure TxyEdit.RadioButton4Click(Sender: TObject);
begin
  if not editing then exit;
  if radiobutton4.checked then
    fGraph.legend.Layout := lsAcross
  else
    FGraph.legend.layout := lsDown;
end;

procedure TxyEdit.CheckBox16Click(Sender: TObject);
begin
 if editing then
   if checkbox16.checked then
     FGraph.legend.Borderstyle := bsSingle
   else
     FGraph.legend.Borderstyle := bsNone;
end;

procedure TxyEdit.Button15Click(Sender: TObject);
begin
  fd.font := FGraph.legend.font;
  if fd.execute then FGraph.legend.font := fd.font;
end;

procedure TxyEdit.Button6Click(Sender: TObject);
begin
  cd.color := FGraph.legend.Color;
  if cd.execute then
    FGraph.legend.color := cd.color;
end;

procedure TxyEdit.ListBox1Click(Sender: TObject);
begin
 if editing and combobox8.enabled then
  case fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus of
   lsNone    :combobox8.itemindex := 0;
   lsNameOnly:combobox8.itemindex := 1;
   lsPoints  :combobox8.itemindex := 2;
   lsLines   :combobox8.itemindex := 3;
   lsAll     :combobox8.itemindex := 4;
 end;
end;

procedure TxyEdit.ComboBox8Change(Sender: TObject);
begin
  if not editing then exit;
  case combobox8.itemindex of
    0:fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus := lsNone;
    1:fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus := lsnameonly;
    2:fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus := lsPoints;
    3:fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus := lsLines;
    4:fgraph[longint(listbox1.items.objects[listbox1.itemindex])].LegendStatus := lsAll;
  end;
end;

function editxyGraph;
begin
  result := true;
  xyedit := txyedit.create(AOwner);
  try
   xyedit.graph := AxyGraph;
   if xyedit.showmodal = mrOK then AxyGraph.assign(xyedit.graph);
  finally
   xyedit.free;
  end;
end;


procedure TxyEdit.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  if newtab > 2 then
    begin
    _MainPanel.visible := true;
    case newtab of
      3:currentaxis := FGraph.XAxis;
      4:currentaxis := FGraph.YAxis;
      5:currentaxis := FGraph.YAxis_second;
    end;
    updateaxespage;
    end
  else
    _MainPanel.visible := false;
end;

procedure TxyEdit.BitBtn3Click(Sender: TObject);
begin
  notebook1.pageindex := (notebook1.pageindex + 1) mod 2;
  case notebook1.pageindex of
   1:bitbtn3.caption := 'Edit';
   0:bitbtn3.caption := 'Preview';
  end;
end;

end.

